{- replace all of this by EnumList? -}

module Conflict(Conflict(..),BasicConstraint,emptyConflict,isEmpty,conflict,isEquality,conflictFromVarAss,Conflict.filter,add,Conflict.size,Conflict.foldl,Conflict.mapMaybe,Conflict.union,Conflict.combConfl) where

import DataEntity
import PredSym
import VarAss
import Debug.Trace
import Data.Maybe
import Data.Set as Set
import Data.List as List

type BasicConstraint = (DataEntity, PredSym, Integer)
data Conflict =  Conflict [ BasicConstraint ]

instance Show Conflict where
  show = showConflict

showConflict (Conflict l)= show l

emptyConflict= Conflict []

isEmpty (Conflict [])= True
isEmpty _= False

c l = Conflict l

conflict:: DataEntity -> PredSym -> Integer -> Conflict
conflict d Equal k = c [ (d, Equal, k) ]
conflict d LessEq k = c [ (d, LessEq, k) ]
conflict d GreaterEq k = c [ (d, GreaterEq, k) ]

isEquality (_, Equal, _)= True
isEquality _ = False

size:: Conflict -> Int
size (Conflict l)= List.length l

combConfl:: Conflict -> Conflict -> Conflict
combConfl c1 c2 = Conflict.union c1 c2

{-- buggy version based on intersection between v and vars which removes array entries still having default values
conflictFromVarAss:: VarAss -> (Set DataEntity) -> Conflict
conflictFromVarAss v vars =
  let convert (d, val) = (d, Equal, val) in
  let setMember (d, val)= Set.member d vars in
  let assocs= VarAss.assocs v in
  let filter= List.filter setMember assocs in
  c (List.map convert filter)
--}

conflictFromVarAss:: VarAss -> (Set DataEntity) -> Conflict
conflictFromVarAss v vars =
  let convert d = (d, Equal, VarAss.lookup v d) in
  let varList= Set.toList vars in
  c (List.map convert varList)
  
filter:: (BasicConstraint -> Bool) -> Conflict -> Conflict
filter f (Conflict l)  = Conflict (List.filter f l)

add:: Conflict -> BasicConstraint -> Conflict
add (Conflict c) bc = Conflict (bc:c)

foldl f init (Conflict l)= List.foldl f init l

mapMaybe f (Conflict l)= Data.Maybe.mapMaybe f l

union (Conflict c1) (Conflict c2)= Conflict (c1 ++ c2)
