module DataEntity where

import Type
import Data.Maybe
import IntEnumerator

type VariableName = String

data DataEntity =
  Integer VariableName |
  Function VariableName Integer deriving (Eq, Ord)  -- maybe, at some point, replace variable precision Integer by machine-precision Int

varName (Integer v)= v
varName (Function v i)= v

isFunc (Integer _) = False
isFunc (Function _ _) = True

showDataEntity (Integer v)= v
showDataEntity (Function v i)= v++"("++(show i)++")"

dataEntityFromDecl (varName, TypeInteger) = Just (Integer varName)
dataEntityFromDecl _ = Nothing

defaultVal= fromJust (firstVal IntEnumerator.unboundedEnumerator)

instance Show DataEntity where
  show = showDataEntity
