module ExecResult where

import Conflict
import VarAss

-- keep this open (as a type) since we do a lot of pattern matching again it in Spec.hs

type ExecResult = Maybe (Bool, Conflict, VarAss)

negate (Just (b, c, w)) = Just (not b, c, w)
negate Nothing = Nothing


emptyWitness= emptyVarAss

execResult b conf = Just (b, conf, emptyVarAss)
execResultUnsat = execResult False emptyConflict

conj:: ExecResult -> ExecResult -> ExecResult
conj r1 r2 =
  case r1 of
    Nothing -> Nothing
    Just (True, conflict1,_) ->
      case r2 of
        Nothing -> Nothing
        Just (True, conflict2, _) -> Just (True, combConfl conflict1 conflict2, emptyWitness)
        r@_ -> r
    r@_ -> r

  
disj:: ExecResult -> ExecResult -> ExecResult
disj r1 r2 =
  case r1 of
    Nothing -> Nothing
    Just (False, conflict1,_) ->
      case r2 of
        Nothing -> Nothing
        Just (False, conflict2, _) -> Just (False, combConfl conflict1 conflict2, emptyWitness)
        r@_ -> r
    r@_ -> r  
