import Spec  
import Text.Parsec
import Debug.Trace
import Data.List as List
import System.Environment

version="0.3"

flagSmtlibs:: [String] -> Bool
flagSmtlibs args =
  let smtlib s = s=="-smtlib" in
  any smtlib args

flagHelp:: [String] -> Bool
flagHelp args =
  let smtlib s = s=="-h" in
  any smtlib args

main =
  do
{-    putStrLn (show enumTest) -}
    args <- getArgs
    if flagHelp args then
      do
        putStrLn ("exspec "++version++" (Stefan Ratschan)")
        putStrLn ""
        putStrLn "Options:"
        putStrLn "  -h: print usage information"
        putStrLn "  -smtlib: convert input to smtlib"
    else
      do
        example <- getContents
        case parse parseSpecification "" example of
          Left error ->
            print error
          Right spec ->
            if flagSmtlibs args then
              print (smtLib spec)
            else  
              do
                putStrLn (showSpecification spec)
                putStrLn (show (sat spec))

