module PredSym where

data PredSym =
  Equal | NotEq | GreaterEq | LessEq | Greater| Less deriving (Eq)

instance Show PredSym where
  show = showPredSym True

showPredSym _ Equal= "="
showPredSym True NotEq= "≠"
showPredSym False NotEq= "<>"
showPredSym True GreaterEq= "≥"
showPredSym False GreaterEq= ">="
showPredSym True LessEq= "≤"
showPredSym False LessEq= "<="
showPredSym _ Greater= ">"
showPredSym _ Less= "<"

negPred Equal = NotEq
negPred NotEq = Equal
negPred GreaterEq = Less
negPred LessEq = Greater
negPred Greater = LessEq
negPred Less = GreaterEq

predOp:: PredSym -> Integer -> Integer -> Bool
predOp Equal = (==)
predOp NotEq = (/=)
predOp GreaterEq = (>=)
predOp LessEq = (<=)
predOp Greater = (>)
predOp Less = (<)
