module VarAss(VarAss,emptyVarAss,toAss,varAssExtend,VarAss.lookup,showVarAss) where

import Data.Map.Ordered as OMap
import Data.List as List
import Data.String
import Data.Maybe
import DataEntity
import IntEnumerator

type VarAss= VarAssOMap

newtype VarAssOMap= VarAssOMap (OMap DataEntity Integer)

instance Show VarAssOMap where
  show= showVarAss

emptyVarAss= VarAssOMap OMap.empty

toAss:: [DataEntity] -> [Integer] -> VarAssOMap
toAss dataEntity tuple | (List.length dataEntity)>=(List.length tuple) =
   let padDefault =  List.replicate ((List.length tuple)-(List.length dataEntity)) defaultVal in
   VarAssOMap (OMap.fromList (List.zip dataEntity (tuple ++ padDefault)))

varAssExtend:: VarAssOMap -> VarAssOMap -> VarAssOMap
varAssExtend (VarAssOMap v1) (VarAssOMap v2) = VarAssOMap (v1 <>| v2)

lookup:: VarAssOMap -> DataEntity -> Integer
lookup (VarAssOMap v) d =
  case OMap.lookup d v of
    Just k -> k
    Nothing -> defaultVal

{-
assocs:: VarAssOMap -> [ (DataEntity, Integer) ]
assocs (VarAssOMap v) = OMap.assocs v

member:: VarAssOMap -> DataEntity -> Bool
member (VarAssOMap v) d = OMap.member d v
-}

showVarAss:: VarAssOMap -> String
showVarAss (VarAssOMap varAss) =
  let assoc = OMap.assocs varAss in
  let funcs = List.filter (isFunc . fst) assoc in
  let funcNames = List.nub (List.map (varName . fst) funcs) in
  let scalars = List.filter ((not . isFunc) . fst) assoc in
  let showElem (k, t) = ((show k)++": "++(show t)):: String in
  let showList l = List.map showElem l in
  let compareIndex ((Function _ i1), _) ((Function _ i2), _) = compare i1 i2 in
  let showFunc name = showList (sortBy compareIndex ((List.filter (\(entity, _) -> (varName entity)==name) funcs))) in
  Data.String.unlines ((showList scalars) ++ (List.concat (List.map showFunc funcNames)))


